## cowdancer 0.10

=== Makefile ===
BINARY=libcowdancer.so cow-shell
INSTALL_DIR=install -d -o root -g root -m 755
INSTALL_FILE=install -o root -g root -m 644
INSTALL_PROGRAM=install -o root -g root -m 755
DESTDIR=
export VERSION=$(shell sed -n '1s/.*(\(.*\)).*$$/\1/p' < debian/changelog )

all: $(BINARY)

install: $(BINARY)
	$(INSTALL_DIR) $(DESTDIR)/usr/lib/cowdancer/
	$(INSTALL_DIR) $(DESTDIR)/usr/share/man/man1/
	$(INSTALL_FILE)  cow-shell.1 $(DESTDIR)/usr/share/man/man1/cow-shell.1
	$(INSTALL_FILE)  libcowdancer.so $(DESTDIR)/usr/lib/cowdancer/libcowdancer.so
	$(INSTALL_PROGRAM) cow-shell $(DESTDIR)/usr/bin/cow-shell

libcowdancer.so: cowdancer.lo
	gcc -ldl -shared -o $@ $<

cow-shell: cow-shell.o

%.lo: %.c
	gcc -D_REENTRANT -fPIC $< -o $@ -c -Wall -O2 -g

%.o: %.c
	gcc $< -o $@ -c -Wall -O2 -g 

clean: 
	-rm *~ *.o *.lo $(BINARY)

upload-dist-all:
	scp ../cowdancer_$(VERSION).tar.gz viper2.netfort.gr.jp:public_html/software/downloads

check:
	set -e; set -o pipefail; for A in tests/???_*.sh; do echo $$A; bash $$A  2>&1 | tee tests/log/$${A/*\//}.log; done

.PHONY: clean check upload-dist-all

=== debian/changelog ===
cowdancer (0.10) unstable; urgency=low

  * fixed pthread race condition.

 -- Junichi Uekawa <dancer@debian.org>  Sat, 14 Jan 2006 22:28:03 +0900

cowdancer (0.9) unstable; urgency=low

  * Reorder the flow of execution for the case when /lib/ld.so binary is
    written to; I cannot fork/exec shared binaries while modifying ld.so.

 -- Junichi Uekawa <dancer@debian.org>  Mon,  9 Jan 2006 00:48:17 +0900

cowdancer (0.8) unstable; urgency=low

  * speed improvement when handling ilist file; when handling linux kernel
    source tree, performance degradation was around 6x in 0.7, but it's
    now 1.1x on my test system.
  - Use mmap and binary data format  
  - Use qsort/bsearch on this data format.
  * update README.Debian.

 -- Junichi Uekawa <dancer@debian.org>  Sat,  7 Jan 2006 11:56:06 +0900

cowdancer (0.7) unstable; urgency=low

  * Work around stat change with coreutils 5.3.0 and later
  * Fix testsuite
  * COWDANCER_DEBUG environmental variable enables debug messages.

 -- Junichi Uekawa <dancer@debian.org>  Wed, 23 Nov 2005 14:08:51 +0900

cowdancer (0.6) unstable; urgency=low

  * add chmod/chown support. (closes: #329383)
  - does not fully support fchmod/fchown, 
    apt/dpkg apparently uses that operation.
    will need to investigate further.
  - debian/TODO: added
  * Clear memory before use on ilist; fixes problem on ppc.

 -- Junichi Uekawa <dancer@debian.org>  Wed,  2 Nov 2005 09:07:01 +0900

cowdancer (0.5) unstable; urgency=low

  * cowdancer: cow-shell does not start, gives error (closes: #329344)

 -- Junichi Uekawa <dancer@debian.org>  Wed, 21 Sep 2005 22:54:34 +0900

cowdancer (0.4) unstable; urgency=low

  * added some error checking 
  * Initial upload to Debian archive (closes: #325370)

 -- Junichi Uekawa <dancer@debian.org>  Tue, 30 Aug 2005 08:36:07 +0900

cowdancer (0.3) unstable; urgency=low

  * add testsuite.
  * find -xdev to avoid looking into /proc
  * Try not to COW device files, only handle regular files
  * symlinks support
  * trap fopen/fopen64 as well as open/open64.
  - enough features to run pbuilder 0.130

 -- Junichi Uekawa <dancer@debian.org>  Sat, 20 Aug 2005 10:10:47 +0900

cowdancer (0.2) unstable; urgency=low

  * Fix buffer overflow.

 -- Junichi Uekawa <dancer@debian.org>  Sat, 13 Aug 2005 21:38:22 +0900

cowdancer (0.1) unstable; urgency=low

  * Initial Release

 -- Junichi Uekawa <dancer@debian.org>  Sat, 13 Aug 2005 21:08:03 +0900

=== debian/control ===
Source: cowdancer
Section: utils
Priority: optional
Maintainer: Junichi Uekawa <dancer@debian.org>
Build-Depends: debhelper (>> 4.0.0)
Standards-Version: 3.6.2

Package: cowdancer
Architecture: any
Depends: ${shlibs:Depends}
Description: Copy-on-write directory tree utility.
 Tries to make copy-on-write semantics upon hard-link copied
 directory trees generated with 'cp -la'
 .
 'cow-shell' command invokes a shell session. Within that session,
 under the directory cow-shell was invoked, 
 cowdancer will create a new file when existing i-nodes are opened for 
 write.
 .
 Useful for quick scratch workspace and experimentation.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS = -Wall -g
INSTALL = install
export INSTALL_FILE    = $(INSTALL) -p    -o root -g root  -m  644
export INSTALL_PROGRAM = $(INSTALL) -p    -o root -g root  -m  755
export INSTALL_SCRIPT  = $(INSTALL) -p    -o root -g root  -m  755
export INSTALL_DIR     = $(INSTALL) -p -d -o root -g root  -m  755

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
INSTALL_PROGRAM += -s
endif


configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir
	$(MAKE)
	#$(MAKE) check
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	-$(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/dsh.
	$(MAKE) install DESTDIR=$(CURDIR)/debian/cowdancer

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs NEWS
	dh_installexamples
	dh_installmenu
	dh_installman
	dh_installchangelogs ChangeLog
	dh_link
	dh_strip
	dh_shlibdeps
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## cowdancer 0.23~bpo.1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-BINARY=libcowdancer.so cow-shell
+BINARY=libcowdancer.so cow-shell cowbuilder
 INSTALL_DIR=install -d -o root -g root -m 755
 INSTALL_FILE=install -o root -g root -m 644
 INSTALL_PROGRAM=install -o root -g root -m 755
@@ -10,14 +10,19 @@
 install: $(BINARY)
 	$(INSTALL_DIR) $(DESTDIR)/usr/lib/cowdancer/
 	$(INSTALL_DIR) $(DESTDIR)/usr/share/man/man1/
+	$(INSTALL_DIR) $(DESTDIR)/usr/share/man/man8/
 	$(INSTALL_FILE)  cow-shell.1 $(DESTDIR)/usr/share/man/man1/cow-shell.1
+	$(INSTALL_FILE)  cowbuilder.8 $(DESTDIR)/usr/share/man/man8/cowbuilder.8
 	$(INSTALL_FILE)  libcowdancer.so $(DESTDIR)/usr/lib/cowdancer/libcowdancer.so
 	$(INSTALL_PROGRAM) cow-shell $(DESTDIR)/usr/bin/cow-shell
+	$(INSTALL_PROGRAM) cowbuilder $(DESTDIR)/usr/sbin/cowbuilder
 
 libcowdancer.so: cowdancer.lo
 	gcc -ldl -shared -o $@ $<
 
 cow-shell: cow-shell.o
+
+cowbuilder: cowbuilder.o
 
 %.lo: %.c
 	gcc -D_REENTRANT -fPIC $< -o $@ -c -Wall -O2 -g
@@ -26,7 +31,7 @@
 	gcc $< -o $@ -c -Wall -O2 -g 
 
 clean: 
-	-rm *~ *.o *.lo $(BINARY)
+	-rm -f *~ *.o *.lo $(BINARY)
 
 upload-dist-all:
 	scp ../cowdancer_$(VERSION).tar.gz viper2.netfort.gr.jp:public_html/software/downloads

=== debian/changelog ===
cowdancer (0.23~bpo.1) sarge-backports; urgency=low

  * Rebuild for Backports.org

 -- Mohammed Adnène Trojette <adn+deb@diwi.org>  Mon, 13 Nov 2006 22:11:32 +0100

cowdancer (0.23) unstable; urgency=low

  * cowbuilder --update ignored command-line options; fix.

 -- Junichi Uekawa <dancer@debian.org>  Thu, 31 Aug 2006 07:30:23 +0900

cowdancer (0.22) unstable; urgency=low

  * Bug fix: "cowdancer: documentation fix to document that
    --debootstrapopts etc can be used with cowbuilder", thanks to Pierre
    Habouzit (Closes: #384030).
  * update README.Debian

 -- Junichi Uekawa <dancer@debian.org>  Sat, 26 Aug 2006 09:07:25 +0900

cowdancer (0.21) unstable; urgency=low

  * Do not clean up if return code from pbuilder looks wrong.

 -- Junichi Uekawa <dancer@debian.org>  Sun, 20 Aug 2006 15:08:43 +0900

cowdancer (0.20) unstable; urgency=low

  * Bug fix: "cowdancer: cowbuilder removes base.cow after failed
    --update", thanks to Jorda Polo (Closes: #379797).

 -- Junichi Uekawa <dancer@debian.org>  Wed, 26 Jul 2006 08:35:42 +0900

cowdancer (0.19) unstable; urgency=low

  * actually support --buildplace and fix --basepath. Thanks to Jonas
    Smedegaard for the patch.  (closes: #375019)

 -- Junichi Uekawa <dancer@debian.org>  Tue, 27 Jun 2006 00:07:08 +0900

cowdancer (0.18) unstable; urgency=low

  * cow-shell: COWDANCER_REUSE=yes: reuse .ilist instead of regenerating.
  * cowbuilder: use COWDANCER_REUSE=yes option to avoid excessive call to
    find/xargs. Speeds up pbuilder-satisfydepends considerably, making
    cowbuilder build faster.

 -- Junichi Uekawa <dancer@debian.org>  Wed, 21 Jun 2006 08:34:39 +0900

cowdancer (0.17) unstable; urgency=low

  * mkdir with right permission 0777, not 777.

 -- Junichi Uekawa <dancer@debian.org>  Thu, 15 Jun 2006 08:36:43 +0900

cowdancer (0.16) unstable; urgency=low

  * add test case for sid/etc debootstrap with cdebootstrap and
    debootstrap.
  * Avoid unneeded cowlinkbreak when hardlink number is 1. Caused some
    problems with dpkg-gencontrol. (Closes: #369261).
  * Standards-version: 3.7.2
  * Error out when there is no file in directory to cowprotect.

 -- Junichi Uekawa <dancer@debian.org>  Sun, 11 Jun 2006 15:04:49 +0900

cowdancer (0.15) unstable; urgency=low

  * cowbuilder: give out help message
  * Bug fix: "cowbuilder silently ignore --basepath option if argument
    does not exists", thanks to Marco Nenciarini (Closes: #369220).
  * Bug fix: "manpage for cowbuilder speaks about nonexistent --basetgz
    option", thanks to Marco Nenciarini (Closes: #369211).
  * Bug fix: "cowdancer: cowbuilder fails after invocation of `pbuilder
    clean`", thanks to Edward J. Shornock (Closes: #369258).

 -- Junichi Uekawa <dancer@debian.org>  Mon, 29 May 2006 07:24:07 +0900

cowdancer (0.14) unstable; urgency=low

  * Welcome to cowbuilder, which can be used along with pbuilder.

 -- Junichi Uekawa <dancer@debian.org>  Fri, 26 May 2006 06:32:21 +0900

cowdancer (0.13) unstable; urgency=low

  * use exec instead of system, so that it will work with ' and spaces.

 -- Junichi Uekawa <dancer@debian.org>  Sun,  5 Mar 2006 22:58:16 +0900

cowdancer (0.12) unstable; urgency=low

  * add support for space in filenames.
  - Bug fix: "cowdancer: dpatches with spaces in their name fail to
    apply", thanks to Paul Wise (Closes: #355358).

 -- Junichi Uekawa <dancer@debian.org>  Sun,  5 Mar 2006 19:31:34 +0900

cowdancer (0.11) unstable; urgency=low

  * add error-handling

 -- Junichi Uekawa <dancer@debian.org>  Thu, 26 Jan 2006 08:14:22 +0900

## cowdancer 0.25

=== Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 	gcc -D_REENTRANT -fPIC $< -o $@ -c -Wall -O2 -g
 
 %.o: %.c
-	gcc $< -o $@ -c -Wall -O2 -g 
+	gcc $< -o $@ -c -Wall -O2 -g -fno-strict-aliasing
 
 clean: 
 	-rm -f *~ *.o *.lo $(BINARY)

=== debian/changelog ===
cowdancer (0.25) unstable; urgency=low

  * Bug fix: "cowdancer: Better explain how to use cowbuilder to build
    packages", thanks to Nelson A. de Oliveira (Closes: #405090).
  * Bug fix: "cowdancer: cannot build gnustep-base with cowbuilder",
    thanks to Hubert Chan (Closes: #402669).
    Do not canonicalize lchown.

 -- Junichi Uekawa <dancer@debian.org>  Sun, 31 Dec 2006 15:54:09 +0900

cowdancer (0.24) unstable; urgency=low

  * testsuite update
  * Bug fix: "--save-after-login hardlinks aptcache contents in base.cow",
    thanks to Matti Lindell (Closes: #384132).

 -- Junichi Uekawa <dancer@debian.org>  Thu, 23 Nov 2006 15:00:59 +0900

=== debian/control ===
Source: cowdancer
Section: utils
Priority: optional
Maintainer: Junichi Uekawa <dancer@debian.org>
Build-Depends: debhelper (>> 4.0.0)
Standards-Version: 3.7.2

Package: cowdancer
Architecture: any
Depends: ${shlibs:Depends}
Recommends: pbuilder
Description: Copy-on-write directory tree utility.
 Tries to make copy-on-write semantics upon hard-link copied
 directory trees generated with 'cp -la'
 .
 'cow-shell' command invokes a shell session. Within that session,
 under the directory cow-shell was invoked, 
 cowdancer will create a new file when existing i-nodes are opened for 
 write.
 Useful for quick scratch workspace and experimentation.
 .
 'cowbuilder' command is a wrapper for pbuilder which allows using 
 pbuilder-like interface over cowdancer environment.

## cowdancer 0.41

=== Makefile ===
BINARY=libcowdancer.so cow-shell cowbuilder qemubuilder cowdancer-ilistcreate \
	cowdancer-ilistdump
INSTALL_DIR=install -d -o root -g root -m 755
INSTALL_FILE=install -o root -g root -m 644
INSTALL_PROGRAM=install -o root -g root -m 755
DESTDIR=
PREFIX=/usr
LIBDIR=$(PREFIX)/lib
export VERSION=$(shell sed -n '1s/.*(\(.*\)).*$$/\1/p' < debian/changelog )

all: $(BINARY)

install: $(BINARY)
	$(INSTALL_DIR) $(DESTDIR)${PREFIX}/bin
	$(INSTALL_DIR) $(DESTDIR)${LIBDIR}/cowdancer
	$(INSTALL_DIR) $(DESTDIR)${PREFIX}/share/man/man1
	$(INSTALL_DIR) $(DESTDIR)${PREFIX}/share/man/man8
	$(INSTALL_FILE)  cow-shell.1 $(DESTDIR)/usr/share/man/man1/cow-shell.1
	$(INSTALL_FILE)  cowdancer-ilistcreate.1 $(DESTDIR)/usr/share/man/man1/cowdancer-ilistcreate.1
	$(INSTALL_FILE)  cowdancer-ilistdump.1 $(DESTDIR)/usr/share/man/man1/cowdancer-ilistdump.1
	$(INSTALL_FILE)  cowbuilder.8 $(DESTDIR)/usr/share/man/man8/cowbuilder.8
	$(INSTALL_FILE)  qemubuilder.8 $(DESTDIR)/usr/share/man/man8/qemubuilder.8
	$(INSTALL_FILE)  libcowdancer.so $(DESTDIR)${LIBDIR}/cowdancer/libcowdancer.so
	$(INSTALL_PROGRAM) cow-shell $(DESTDIR)/usr/bin/cow-shell
	$(INSTALL_PROGRAM) cowbuilder $(DESTDIR)/usr/sbin/cowbuilder
	$(INSTALL_PROGRAM) qemubuilder $(DESTDIR)/usr/sbin/qemubuilder
	$(INSTALL_PROGRAM) cowdancer-ilistcreate $(DESTDIR)/usr/bin/cowdancer-ilistcreate
	$(INSTALL_PROGRAM) cowdancer-ilistdump $(DESTDIR)/usr/bin/cowdancer-ilistdump

libcowdancer.so: cowdancer.lo ilistcreate.lo
	gcc -O2 -Wall -ldl -shared -o $@ $^

cow-shell: cow-shell.o ilistcreate.o
	gcc -O2 -Wall -o $@ $^

cowdancer-ilistcreate: cowdancer-ilistcreate.o ilistcreate.o
	gcc -O2 -Wall -o $@ $^

cowbuilder: cowbuilder.o parameter.o forkexec.o ilistcreate.o
	gcc -O2 -Wall -o $@ $^

qemubuilder: qemubuilder.o parameter.o forkexec.o
	gcc -O2 -Wall -o $@ $^

%.lo: %.c 
	gcc -D_REENTRANT -fPIC $< -o $@ -c -Wall -O2 -g

%.o: %.c parameter.h
	gcc $< -o $@ -c -Wall -O2 -g -fno-strict-aliasing -D LIBDIR="\"${LIBDIR}\""

clean: 
	-rm -f *~ *.o *.lo $(BINARY)

upload-dist-all:
	scp ../cowdancer_$(VERSION).tar.gz aegis.netfort.gr.jp:public_html/software/downloads

check:
	set -e; set -o pipefail; for A in tests/???_*.sh; do echo $$A; bash $$A  2>&1 | \
	sed -e's,/tmp/[^/]*,/tmp/XXXX,g' \
	    -e "s,^Current time:.*,Current time: TIME," \
	    -e "s,^pbuilder-time-stamp: .*,pbuilder-time-stamp: XXXX," \
	    -e "s,^Fetched .*B in .*s (.*B/s),Fetched XXXB in Xs (XXXXXB/s)," \
	| tee tests/log/$${A/*\//}.log; done

check-syntax:
	gcc -c -O2 -Wall $(CHK_SOURCES)  -o/dev/null -D LIBDIR="\"${LIBDIR}\""

.PHONY: clean check upload-dist-all check-syntax

=== debian/changelog ===
cowdancer (0.41) unstable; urgency=low

  * Bug fix: "qemubuilder: build of package failing due to date problems",
    thanks to Jean-Baptiste Note (Closes: #441132).
  * Bug fix: "newly created cowdancer chroot cannot be updated", thanks to
    Paul Wise (Closes: #441463).
  - there was a race condition with .ilist handling.

 -- Junichi Uekawa <dancer@debian.org>  Mon, 10 Sep 2007 19:50:31 +0900

cowdancer (0.40) unstable; urgency=low

  * Bug fix: "cowdancer: Should remove base directory when failed to
    create it", thanks to Nelson A. de Oliveira (Closes: #440651).
  * cow-shell: if COWDANCER_REUSE is not set, remove .ilist file after use.
    (Closes: #350268).
  * Bug fix: "cowdancer: <sys/types.h> needed in cowdancer-ilistcreate.c
    for Etch backport", thanks to Sven Hartge (Closes: #440879).
  * update qemubuilder README.Debian 
  * Don't assume network is always available as 'eth0', and try to find
    out. patch thanks to Jean-Baptiste Note (Closes: #440888).

 -- Junichi Uekawa <dancer@debian.org>  Fri, 07 Sep 2007 08:29:31 +0900

cowdancer (0.39) unstable; urgency=low

  * Bug fix: "qemubuilder: Problem when non-US locale", thanks to
    Jean-Baptiste Note (Closes: #440558).
  * Give fd0 directly to qemu to allow tty control.
  * Handle exit codes.
  * apply patch to more easily handle newer architecture support, 
    thanks to Jean-Baptiste Note: #440555

 -- Junichi Uekawa <dancer@debian.org>  Tue, 04 Sep 2007 08:31:55 +0900

cowdancer (0.38) unstable; urgency=low

  [ Jan-Marek Glogowski ] 
  * Don't clean the environment when invoking dumpconfig 
  (closes: #431993)
  * Better error handling when loading config

  [ Junichi Uekawa ]
  * add aptitude into chroot for pbuilder-satisfydepends-aptitude.
  * add cowdancer-ilistcreate command, which creates ilist file.
  * add cowdancer-ilistdump command, for debugging purposes. It was
    included in the testsuite, but it is generally useful for
    troubleshooting.
  * run cowdancer-ilistcreate within chroot if it exists
  - Bug fix: "cowbuilder cross-arch building support."
    (Closes: #432573).

 -- Junichi Uekawa <dancer@debian.org>  Sat, 01 Sep 2007 13:10:45 +0900

cowdancer (0.37) unstable; urgency=low

  * Trying to fix: "tar segfaulting within cowbuilder chroot", thanks to Michael
    Ablassmeier (closes: #430636).
  - work around glibc bug on dlvsym/dlerror failure case.
  * close mmap fd after use.
  
 -- Junichi Uekawa <dancer@debian.org>  Wed, 27 Jun 2007 07:12:20 +0900

cowdancer (0.36) unstable; urgency=low

  * fix logic for running amd64 on i386.
  * add example for cowbuilder manpage.
  * add --dumpconfig option.
  * Bug fix: "cowbuilder ignores BUILDPLACE", thanks to Guido Guenther
    (Closes: #429058).
  * Bug fix: "qemubuilder: --distribution is not honored", thanks to Ben
    Voui (Closes: #429026).
  * load proper chown for architectures (e.g. i386) which have two
    versions of chown.
  * Bug fix: "qemubuilder: manpage talks of cowbuilder instead of
    qemubuilder", thanks to Ben Voui (Closes: #428959).

 -- Junichi Uekawa <dancer@debian.org>  Mon, 25 Jun 2007 21:26:02 +0900

cowdancer (0.35) unstable; urgency=low

  * add README.Debian to qemubuilder.
  * libcowdancer: change exported symbol names to be less generic.

 -- Junichi Uekawa <dancer@debian.org>  Sat, 09 Jun 2007 22:37:45 +0900

cowdancer (0.34) unstable; urgency=low

  * qemubuilder: fix segv.
  * Bug fix: "big bind mounts make login take a looong time", thanks to
    Joey Hess (Closes: #410723).  
  
    Special-case ./home/ so that it's not scanned for cowbuilder. Usually,
    only the filesystem outside of /home is interesting for cowbuilder
    sessions.
  
 -- Junichi Uekawa <dancer@debian.org>  Sat, 09 Jun 2007 15:16:07 +0900

cowdancer (0.33) unstable; urgency=low

  * qemubuilder: support signed .dsc files
  * qemubuilder: install to /usr/sbin/ instead of /usr/bin.
   (Closes: #427786).

 -- Junichi Uekawa <dancer@debian.org>  Wed, 06 Jun 2007 21:00:46 +0900

cowdancer (0.32) unstable; urgency=low

  * Try again, call debhelper with '-s' so that it doesn't try to build
    everything on all architectures (Closes: #427650).

 -- Junichi Uekawa <dancer@debian.org>  Wed, 06 Jun 2007 08:11:54 +0900

cowdancer (0.31) unstable; urgency=low

  * cowbuilder: pass --configfile option through to pbuilder.
  * cowbuilder, qemubuilder: reorganize code, to put shared code into
    parameter.[ch]

 -- Junichi Uekawa <dancer@debian.org>  Wed, 06 Jun 2007 07:54:24 +0900

cowdancer (0.30) unstable; urgency=low

  * Bug fix: "FTBFS: cowdancer_0.29(alpha/unstable): b-d on qemu not
    satisfiable on all archs", thanks to Steve Langasek (Closes: #427650).
    only build on i386, amd64, and powerpc.

 -- Junichi Uekawa <dancer@debian.org>  Tue, 05 Jun 2007 22:50:30 +0900

cowdancer (0.29) unstable; urgency=low

  * qemubuilder, cowbuilder: 'set -e' when sourcing configuration file.
  * Build-Depend on qemu, which is needed for testing.
  
 -- Junichi Uekawa <dancer@debian.org>  Tue, 05 Jun 2007 21:12:02 +0900

cowdancer (0.28) unstable; urgency=low

  * qemubuilder: add example pbuilderrc and document ARCH= option in
    manpage.
  * Build-Depend on pbuilder, since cowbuilder/qemubuilder testsuite
    requires pbuilder to run.

 -- Junichi Uekawa <dancer@debian.org>  Mon, 04 Jun 2007 07:28:22 +0900

cowdancer (0.27) unstable; urgency=low

  * support configuration files in cowbuilder.
  - fixes: "no easy way to specify an alternative basepath", thanks to
    Guido Guenther (Closes: #426589).
  - change Recommends to Depends on pbuilder, since configuration files
    are provided by pbuilder.
  * add reference to pbuilder documentation from cowbuilder documentation.
  * add qemubuilder package. -- this is more of a prototype, but enjoy.

 -- Junichi Uekawa <dancer@debian.org>  Wed, 30 May 2007 09:20:22 +0900

cowdancer (0.26) unstable; urgency=low

  * spec file, port to rpm-based systems.


=== debian/control ===
--- 
+++ 
@@ -2,13 +2,12 @@
 Section: utils
 Priority: optional
 Maintainer: Junichi Uekawa <dancer@debian.org>
-Build-Depends: debhelper (>> 4.0.0)
+Build-Depends: debhelper (>> 4.0.0), pbuilder, qemu [i386 amd64 powerpc]
 Standards-Version: 3.7.2
 
 Package: cowdancer
 Architecture: any
-Depends: ${shlibs:Depends}
-Recommends: pbuilder
+Depends: ${shlibs:Depends}, pbuilder
 Description: Copy-on-write directory tree utility.
  Tries to make copy-on-write semantics upon hard-link copied
  directory trees generated with 'cp -la'
@@ -22,3 +21,17 @@
  'cowbuilder' command is a wrapper for pbuilder which allows using 
  pbuilder-like interface over cowdancer environment.
 
+Package: qemubuilder
+Architecture: i386 amd64 powerpc
+Depends: ${shlibs:Depends}, qemu, pbuilder
+Description: pbuilder using QEMU as backend
+ pbuilder implementation for QEMU.
+ .
+ qemubuilder create -- builds QEMU cow base image.
+ . 
+ qemubuilder update -- updates QEMU cow base image.
+ . 
+ qemubuilder build -- builds package inside QEMU cow base image.
+ .
+ Gives a pbuilder interface for emulated cross-building environments
+ using qemu.

## cowdancer 0.44

=== Makefile ===
--- 
+++ 
@@ -26,6 +26,10 @@
 	$(INSTALL_PROGRAM) qemubuilder $(DESTDIR)/usr/sbin/qemubuilder
 	$(INSTALL_PROGRAM) cowdancer-ilistcreate $(DESTDIR)/usr/bin/cowdancer-ilistcreate
 	$(INSTALL_PROGRAM) cowdancer-ilistdump $(DESTDIR)/usr/bin/cowdancer-ilistdump
+
+	$(INSTALL_DIR) $(DESTDIR)/etc/bash_completion.d
+	$(INSTALL_FILE) bash_completion.qemubuilder $(DESTDIR)/etc/bash_completion.d/qemubuilder
+	$(INSTALL_FILE) bash_completion.cowbuilder $(DESTDIR)/etc/bash_completion.d/cowbuilder
 
 libcowdancer.so: cowdancer.lo ilistcreate.lo
 	gcc -O2 -Wall -ldl -shared -o $@ $^

=== debian/changelog ===
cowdancer (0.44) unstable; urgency=low

  * add Vcs-Git, Vcs-Browser.
  * fix invocation to cowdancer-ilistcreate

 -- Junichi Uekawa <dancer@debian.org>  Wed, 21 Nov 2007 22:47:22 +0900

cowdancer (0.43) unstable; urgency=low

  * make cowbuilder work with pdebuild. --debbuildopts handling was broken
    for cowbuilder. (Closes: #448330).

 -- Junichi Uekawa <dancer@debian.org>  Sun, 28 Oct 2007 23:13:42 +0900

cowdancer (0.42) unstable; urgency=low

  * Bug fix: "cowdancer: Please ship a (basic) bash completion file",
    thanks to Cyril Brulebois (Closes: #446498).
  * --components support.
  * Bug fix: "qemubuilder doesn&#39;t pass --debbuildopts to
    dpkg-buildpackage", thanks to Alexander Gerasiov (Closes: #447510).

 -- Junichi Uekawa <dancer@debian.org>  Thu, 25 Oct 2007 20:18:28 +0900

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,8 @@
 Maintainer: Junichi Uekawa <dancer@debian.org>
 Build-Depends: debhelper (>> 4.0.0), pbuilder, qemu [i386 amd64 powerpc]
 Standards-Version: 3.7.2
+Vcs-Git: git://git.debian.org/git/pbuilder/cowdancer.git
+Vcs-Browser: http://git.debian.org/?p=pbuilder/cowdancer.git
 
 Package: cowdancer
 Architecture: any
@@ -23,7 +25,7 @@
 
 Package: qemubuilder
 Architecture: i386 amd64 powerpc
-Depends: ${shlibs:Depends}, qemu, pbuilder
+Depends: ${shlibs:Depends}, qemu, pbuilder (>= 0.174)
 Description: pbuilder using QEMU as backend
  pbuilder implementation for QEMU.
  .

=== debian/rules ===
--- 
+++ 
@@ -47,8 +47,8 @@
 	dh_clean -k
 	dh_installdirs
 
-	# Add here commands to install the package into debian/dsh.
 	$(MAKE) install DESTDIR=$(CURDIR)/debian/cowdancer
+	dh_movefiles -pqemubuilder --sourcedir=debian/cowdancer
 
 # Build architecture-independent files here.
 binary-indep: build install
@@ -56,22 +56,27 @@
 
 # Build architecture-dependent files here.
 binary-arch: build install
-	dh_testdir
-	dh_testroot
-	dh_installdocs NEWS
-	dh_installexamples
-	dh_installmenu
-	dh_installman
-	dh_installchangelogs ChangeLog
-	dh_link
-	dh_strip
-	dh_shlibdeps
-	dh_compress
-	dh_fixperms
-	dh_installdeb
-	dh_gencontrol
-	dh_md5sums
-	dh_builddeb
+	dh_testdir -s 
+	dh_testroot -s 
+	dh_installdocs -s NEWS
+	dh_installexamples -s 
+	dh_installmenu -s 
+	dh_installman -s 
+	dh_installchangelogs -s ChangeLog
+	dh_link -s 
+	dh_strip -s 
+	dh_shlibdeps -s 
+	dh_compress -s 
+	dh_fixperms -s 
+	dh_installdeb -s 
+	dh_gencontrol -s 
+	dh_md5sums -s 
+	dh_builddeb -s 
+
+# (shell-command "cd ../ ; debian/rules debian/qemubuilder.README.Debian")
+debian/qemubuilder.README.Debian:
+	python debian/xmlrpc.py qemubuilder > $@.tmp
+	mv $@.tmp $@
 
 binary: binary-indep binary-arch
-.PHONY: build clean binary-indep binary-arch binary install configure
+.PHONY: build clean binary-indep binary-arch binary install configure debian/qemubuilder.README.Debian

## cowdancer 0.47~bpo40+1

=== debian/changelog ===
cowdancer (0.47~bpo40+1) etch-backports; urgency=low

  * Rebuild for etch-backports.

 -- Philipp Kern <pkern@debian.org>  Fri, 06 Jun 2008 13:06:13 +0200

cowdancer (0.47) unstable; urgency=low

  * Bug fix: "cowdancer: unexpected WIFEXITED status in waitpid", thanks
    to Andreas Beckmann (Closes: #466709).
    Block SIGCHLD when forking cp.

 -- Junichi Uekawa <dancer@debian.org>  Tue, 20 May 2008 07:58:24 +0900

cowdancer (0.46) unstable; urgency=low

  * make cowbuilder work with cowbuilder in etch.  Bug 410723 will revive,
    so it will need --debian-etch-workaround option to enable.
    "provide cowdancer etch support", thanks to Patrick Winnertz
    (Closes: #481344).
  * Add reference to --no-cowdancer-update option in the error message so
    that it's more obvious. (Closes: #481609).

 -- Junichi Uekawa <dancer@debian.org>  Sun, 18 May 2008 12:24:21 +0900

cowdancer (0.45) unstable; urgency=low

  * cowbuilder, qemubuilder: Give error message when '--build' is invoked
    without .dsc file parameter.  (Closes: #460041).
  * output more useful info on waitpid WIFEXITED debug message.
  * add header to .ilist, so that it is possible to know a little bit more
    about the structure.  Note that upgrade will fail within cowdancer
    session, please re-create chroot, or use the --no-cowdancer-update option:

      Unpacking cowdancer (from .../cowdancer_0.45_amd64.deb) ...
      ERROR: ld.so: object '/usr/lib/cowdancer/libcowdancer.so' from LD_PRELOAD cannot be preloaded: ignored.
      cowdancer: .ilist header unexpected
      cowdancer: .ilist header unexpected
      cowdancer: .ilist header unexpected
      dpkg-split: unable to read part file `/tmp/buildd/qemubuilder_0.45_amd64.deb': Cannot allocate memory
      dpkg: error processing /tmp/buildd/qemubuilder_0.45_amd64.deb (--install):
  * Bug fix: "qemubuilder --create installs many useless? packages",
    thanks to David Bremner (Closes: #476547).
    Do not install recommended packages. 
    Qemubuilder now creates '/etc/apt/apt.conf.d/15pbuilder' in the same
    manner as pbuilder.
  * Bug fix: "qemubuilder: Please add kvm as alternate dependency", thanks
    to Josh Triplett (Closes: #479277).

 -- Junichi Uekawa <dancer@debian.org>  Mon, 12 May 2008 08:47:40 +0900

## cowdancer 0.48

=== debian/changelog ===
cowdancer (0.48) unstable; urgency=low

  * qemubuilder: add support for armel.
  * qemubuilder: add support for --arch-diskdevice option so that users of
    Ubuntu i386 kernels can override from default hd to sd.

 -- Junichi Uekawa <dancer@debian.org>  Sun, 10 Aug 2008 23:40:39 +0900

=== debian/control ===
--- 
+++ 
@@ -25,7 +25,7 @@
 
 Package: qemubuilder
 Architecture: i386 amd64 powerpc
-Depends: ${shlibs:Depends}, qemu, pbuilder (>= 0.174)
+Depends: ${shlibs:Depends}, qemu | kvm, pbuilder (>= 0.174)
 Description: pbuilder using QEMU as backend
  pbuilder implementation for QEMU.
  .

## cowdancer 0.56ubuntu3

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,4 @@
+SHELL=/bin/bash
 BINARY=libcowdancer.so cow-shell cowbuilder qemubuilder cowdancer-ilistcreate \
 	cowdancer-ilistdump
 INSTALL_DIR=install -d -o root -g root -m 755
@@ -6,6 +7,10 @@
 DESTDIR=
 PREFIX=/usr
 LIBDIR=$(PREFIX)/lib
+CFLAGS=-O2 -Wall -g -fno-strict-aliasing -D_REENTRANT
+CFLAGS_LFS=$(CFLAGS) $(shell getconf LFS_CFLAGS)
+PWD=$(shell pwd)
+
 export VERSION=$(shell sed -n '1s/.*(\(.*\)).*$$/\1/p' < debian/changelog )
 
 all: $(BINARY)
@@ -32,42 +37,57 @@
 	$(INSTALL_FILE) bash_completion.cowbuilder $(DESTDIR)/etc/bash_completion.d/cowbuilder
 
 libcowdancer.so: cowdancer.lo ilistcreate.lo
-	gcc -O2 -Wall -ldl -shared -o $@ $^
+	$(CC) $(CFLAGS) -ldl -shared -o $@ $^
 
 cow-shell: cow-shell.o ilistcreate.o
-	gcc -O2 -Wall -o $@ $^
+	$(CC) $(CFLAGS) -o $@ $^
 
 cowdancer-ilistcreate: cowdancer-ilistcreate.o ilistcreate.o
-	gcc -O2 -Wall -o $@ $^
+	$(CC) $(CFLAGS) -o $@ $^
 
 cowbuilder: cowbuilder.o parameter.o forkexec.o ilistcreate.o
-	gcc -O2 -Wall -o $@ $^
+	$(CC) $(CFLAGS) -o $@ $^
 
-qemubuilder: qemubuilder.o parameter.o forkexec.o
-	gcc -O2 -Wall -o $@ $^
+qemubuilder: qemubuilder.lfso parameter.lfso forkexec.lfso qemuipsanitize.lfso qemuarch.lfso file.lfso
+	$(CC) $(CFLAGS) -o $@ $^
 
 %.lo: %.c 
-	gcc -D_REENTRANT -fPIC $< -o $@ -c -Wall -O2 -g
+	$(CC) $(CFLAGS) -fPIC $< -o $@ -c
+
+%.lfso: %.c 
+	$(CC) $(CFLAGS_LFS) $< -o $@ -c
 
 %.o: %.c parameter.h
-	gcc $< -o $@ -c -Wall -O2 -g -fno-strict-aliasing -D LIBDIR="\"${LIBDIR}\""
+	$(CC) $(CFLAGS) $< -o $@ -c -D LIBDIR="\"${LIBDIR}\""
 
 clean: 
-	-rm -f *~ *.o *.lo $(BINARY)
+	-rm -f *~ *.o *.lo *.lfso $(BINARY)
+	-make -C initrd clean
 
 upload-dist-all:
 	scp ../cowdancer_$(VERSION).tar.gz aegis.netfort.gr.jp:public_html/software/downloads
 
-check:
-	set -e; set -o pipefail; for A in tests/???_*.sh; do echo $$A; bash $$A  2>&1 | \
+fastcheck:
+	set -e; set -o pipefail; for A in ./test_*.c; do echo $$A; \
+		./tests/run_c.sh $$A 2>&1 | \
+		tee tests/log/$${A/*\//}.log; done
+
+slowcheck: cowdancer-ilistdump qemubuilder cow-shell
+	# FIXME: The tests are running installed cowdancer, not the just-built
+	set -e; set -o pipefail; for A in tests/[0-9][0-9][0-9]_*.sh; \
+	do echo $$A; \
+	PATH="$(PWD):$(PWD)/tests:/usr/bin/:/bin" \
+	COWDANCER_SO=$(PWD)/libcowdancer.so \
+	bash $$A  2>&1 | \
 	sed -e's,/tmp/[^/]*,/tmp/XXXX,g' \
 	    -e "s,^Current time:.*,Current time: TIME," \
 	    -e "s,^pbuilder-time-stamp: .*,pbuilder-time-stamp: XXXX," \
 	    -e "s,^Fetched .*B in .*s (.*B/s),Fetched XXXB in Xs (XXXXXB/s)," \
 	| tee tests/log/$${A/*\//}.log; done
 
+check: fastcheck slowcheck
+
 check-syntax:
-	gcc -c -O2 -Wall $(CHK_SOURCES)  -o/dev/null -D LIBDIR="\"${LIBDIR}\""
+	$(CC) -c $(CFLAGS) $(CHK_SOURCES)  -o/dev/null -D LIBDIR="\"${LIBDIR}\""
 
-.PHONY: clean check upload-dist-all check-syntax
-
+.PHONY: clean check upload-dist-all check-syntax fastcheck slowcheck

=== debian/changelog ===
cowdancer (0.56ubuntu3) karmic; urgency=low

  * Fix test_qemuarch.c test.

 -- Loïc Minier <loic.minier@ubuntu.com>  Tue, 21 Jul 2009 14:51:04 +0200

cowdancer (0.56ubuntu2) karmic; urgency=low

  * Fix FTBFS on lpia by modifying test_qemuarch.c to check 
    for "i386" | "lpia"

 -- Andreas Moog <amoog@ubuntu.com>  Mon, 06 Jul 2009 01:51:05 +0200

cowdancer (0.56ubuntu1) karmic; urgency=low

  * Explicitly use bash as SHELL, the package FTBFS on dash. Patch by
    Stephane Glondu. (LP: #386058)
    Debian report: http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=532444

 -- Andreas Moog <amoog@ubuntu.com>  Thu, 11 Jun 2009 20:31:14 +0200

cowdancer (0.56) unstable; urgency=low

  * minor fix to grammer in cowbuilder.README.Debian (closes: #528559)

 -- Junichi Uekawa <dancer@debian.org>  Sun, 31 May 2009 11:10:53 +0900

cowdancer (0.55) unstable; urgency=low

  * COWDANCER_DEBUG=1 sent some output to stdout which broke some cases,
    now outputs to stderr, which is more safe. (closes: #523575)
  * Now make check runs.
  * environment variable COWDANCER_SO specifies location of
    libcowdancer.so, default is /usr/lib/cowdancer/libcowdancer.so,
    useful for running tests on just-built cowdancer.

 -- Junichi Uekawa <dancer@debian.org>  Mon, 13 Apr 2009 07:58:24 +0900

cowdancer (0.54) unstable; urgency=low

  * Really fix i386 qemubuilder; compile with LFS option.
  * Run 'make fastcheck' after build so that I know builds are reasonable.
    Running 'make slowcheck' needs a bit more work.
  * change bash completion
  * add work-around for udev bug #520742, add /etc/udev/disabled

 -- Junichi Uekawa <dancer@debian.org>  Fri, 10 Apr 2009 07:38:47 +0900

cowdancer (0.53) unstable; urgency=low

  * Fix i386 cowdancer, rollback to only use large file support for
    qemubuilder.  cowbuilder and cowdancer seem to need more changes to
    get LFS working. (closes: #520994)

 -- Junichi Uekawa <dancer@debian.org>  Wed, 25 Mar 2009 08:57:45 +0900

cowdancer (0.52) unstable; urgency=low

  * Fix build error on i386. 
    libcowdancer cannot be built with LFS on i386. Disable LFS for now.
    (closes: #520861)

 -- Junichi Uekawa <dancer@debian.org>  Mon, 23 Mar 2009 22:27:51 +0900

cowdancer (0.51) unstable; urgency=low

  * add largefile support flags so that qemubuilder works properly in
    32-bit mode. (closes: #520721)

 -- Junichi Uekawa <dancer@debian.org>  Mon, 23 Mar 2009 08:32:54 +0900

cowdancer (0.50) unstable; urgency=low

  * add handling for inputfile / outputfile options, --inputfile is
    implemented.
  * do not use external resolv.conf inside qemu.
  * add 'quiet' option to kernel booting inside qemu.
  * Set the current time inside chroot for pbuilder create target as
    well.

 -- Junichi Uekawa <dancer@debian.org>  Sat, 21 Mar 2009 11:08:44 +0900

cowdancer (0.49) unstable; urgency=low

  * qemubuilder: depend on debootstrap. (closes: #496077)
  * cowbuilder package: split out from cowdancer. cowdancer can be useful
    in more cases than cowbuilder. (closes: #459436)
    The two packages depend on both packages in order to not break
    backward compatibility.
  * Add a README.Debian for cowbuilder (closes: #496458)
  * Handle IPv4 'lo' device address (127.0.0.0) for --mirror option
    specially, so that they are translated to 10.0.2.2 inside qemu.
  * qemu: mount sysfs and devpts (closes: #511190)

 -- Junichi Uekawa <dancer@debian.org>  Fri, 20 Feb 2009 22:11:22 +0900

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,19 @@
 Source: cowdancer
 Section: utils
 Priority: optional
-Maintainer: Junichi Uekawa <dancer@debian.org>
-Build-Depends: debhelper (>> 4.0.0), pbuilder, qemu [i386 amd64 powerpc]
+Maintainer: Ubuntu MOTU Developers <ubuntu-motu@lists.ubuntu.com>
+XSBC-Original-Maintainer: Junichi Uekawa <dancer@debian.org>
+Build-Depends: debhelper (>> 4.0.0), pbuilder, qemu [i386 amd64 powerpc], 
+	       libklibc-dev, klibc-utils, cpio, busybox-static
 Standards-Version: 3.7.2
 Vcs-Git: git://git.debian.org/git/pbuilder/cowdancer.git
 Vcs-Browser: http://git.debian.org/?p=pbuilder/cowdancer.git
 
 Package: cowdancer
 Architecture: any
-Depends: ${shlibs:Depends}, pbuilder
+# cowbuilder dependency is for backward compatibility, will be removed
+# after squeeze is released.
+Depends: ${shlibs:Depends}, cowbuilder
 Description: Copy-on-write directory tree utility.
  Tries to make copy-on-write semantics upon hard-link copied
  directory trees generated with 'cp -la'
@@ -20,12 +24,19 @@
  write.
  Useful for quick scratch workspace and experimentation.
  .
+ For a useful Debian tool, try cowbuilder.
+
+Package: cowbuilder
+Architecture: any
+Depends: ${shlibs:Depends}, pbuilder, cowdancer
+Replaces: cowdancer (<= 0.49)
+Description: pbuilder running on cowdancer
  'cowbuilder' command is a wrapper for pbuilder which allows using 
  pbuilder-like interface over cowdancer environment.
 
 Package: qemubuilder
 Architecture: i386 amd64 powerpc
-Depends: ${shlibs:Depends}, qemu | kvm, pbuilder (>= 0.174)
+Depends: ${shlibs:Depends}, qemu | kvm, pbuilder (>= 0.174), debootstrap
 Description: pbuilder using QEMU as backend
  pbuilder implementation for QEMU.
  .

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-CFLAGS = -Wall -g
+CFLAGS = -Wall -g -fno-strict-aliasing -D_REENTRANT
 INSTALL = install
 export INSTALL_FILE    = $(INSTALL) -p    -o root -g root  -m  644
 export INSTALL_PROGRAM = $(INSTALL) -p    -o root -g root  -m  755
@@ -31,7 +31,7 @@
 build-stamp:
 	dh_testdir
 	$(MAKE)
-	#$(MAKE) check
+	$(MAKE) check
 	touch build-stamp
 
 clean:
@@ -49,6 +49,7 @@
 
 	$(MAKE) install DESTDIR=$(CURDIR)/debian/cowdancer
 	dh_movefiles -pqemubuilder --sourcedir=debian/cowdancer
+	dh_movefiles -pcowbuilder --sourcedir=debian/cowdancer
 
 # Build architecture-independent files here.
 binary-indep: build install

## cowdancer 0.61

=== debian/changelog ===
cowdancer (0.61) unstable; urgency=low

  * add --architecture option to qemubuilder and cowbuilder and support
    ARCHITECTURE option in pbuilderrc. (closes: #564796)
    ARCHITECTURE is preferred over ARCH option, but both options will work.
  * add basepath to cowbuilder bash_completion.
  * add basepath and architecture to bash completion for qemubuilder.

 -- Junichi Uekawa <dancer@debian.org>  Fri, 29 Jan 2010 23:30:35 +0900

cowdancer (0.60) unstable; urgency=low

  * cowbuilder: output a more helpful error message when flock/fchmod/fchown is
    called.
  * cowbuilder: call break_cowlink on templates.dat and password.dat. 
    (closes: #558832)

 -- Junichi Uekawa <dancer@debian.org>  Wed, 02 Dec 2009 23:14:33 +0900

cowdancer (0.59) unstable; urgency=low

  [ Junichi Uekawa ]
  * cowbuilder fix "cannot lock DBdriver config" during parallel usage
    (closes: #553616)
  * qemubuilder: use malta architecture for mips and mipsel.
  * Update README.Debian for qemubuilder

 -- Junichi Uekawa <dancer@debian.org>  Sun, 29 Nov 2009 19:28:48 +0900

cowdancer (0.58) unstable; urgency=low

  * support --debbuildopts for cowbuilder (closes: #548209)
  * add debug message so that what's happening is more obvious.
  * make qemubuilder create output more descriptive error message on
    error to create file (closes: #551614)
  * Improve description for cowbuilder and qemubuilder (closes: #551365)

 -- Junichi Uekawa <dancer@debian.org>  Sun, 01 Nov 2009 23:33:31 +0900

cowdancer (0.57) unstable; urgency=low

  [ Loïc Minier ]
  * Set SHELL=/bin/bash for pipefail; (closes: #532444)
  * Allow for lpia dpkg arch for __i386__ arches

  [ Junichi Uekawa ]
  * modify changelog spelling mistake.
  * add homepage for cowdancer and qemubuilder.
  * remove 'man .hy' typo from cowbuilder.8 (closes: #541820)

 -- Junichi Uekawa <dancer@debian.org>  Tue, 25 Aug 2009 22:24:06 +0900

## cowdancer 0.62

=== debian/changelog ===
cowdancer (0.62) unstable; urgency=low

  [ Stefan Kisdaroczi ]
  * set serial console baudrate to 115200 (closes: #587424)
  * use kvm for i386 on amd64 host (closes: #587421)

  [ Junichi Uekawa ]
  * probably, ARM does support 115200n8 too.
  * remove implied -serial=stdio by adding -nodefault. (closes:
    #591470)

 -- Junichi Uekawa <dancer@debian.org>  Sun, 15 Aug 2010 23:43:49 +0900

## cowdancer 0.62+nmu1

=== Makefile ===
--- 
+++ 
@@ -45,10 +45,10 @@
 cowdancer-ilistcreate: cowdancer-ilistcreate.o ilistcreate.o
 	$(CC) $(CFLAGS) -o $@ $^
 
-cowbuilder: cowbuilder.o parameter.o forkexec.o ilistcreate.o
+cowbuilder: cowbuilder.o parameter.o forkexec.o ilistcreate.o main.o
 	$(CC) $(CFLAGS) -o $@ $^
 
-qemubuilder: qemubuilder.lfso parameter.lfso forkexec.lfso qemuipsanitize.lfso qemuarch.lfso file.lfso
+qemubuilder: qemubuilder.lfso parameter.lfso forkexec.lfso qemuipsanitize.lfso qemuarch.lfso file.lfso main.lfso
 	$(CC) $(CFLAGS) -o $@ $^
 
 %.lo: %.c

=== debian/changelog ===
cowdancer (0.62+nmu1) unstable; urgency=low

  * Non-maintainer upload.
  * Apply fix to qemubuilder's mount problem (Closes: #564425)
    Thanks to Benoît Knecht, Gregor Herrmann and Martijn van Brummelen for
    working on the issue!

 -- Alexander Reichle-Schmehl <tolimar@debian.org>  Fri, 26 Nov 2010 16:16:26 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: cowdancer
 Section: utils
 Priority: optional
-Maintainer: Ubuntu MOTU Developers <ubuntu-motu@lists.ubuntu.com>
-XSBC-Original-Maintainer: Junichi Uekawa <dancer@debian.org>
+Maintainer: Junichi Uekawa <dancer@debian.org>
 Build-Depends: debhelper (>> 4.0.0), pbuilder, qemu [i386 amd64 powerpc], 
 	       libklibc-dev, klibc-utils, cpio, busybox-static
 Standards-Version: 3.7.2
@@ -14,6 +13,7 @@
 # cowbuilder dependency is for backward compatibility, will be removed
 # after squeeze is released.
 Depends: ${shlibs:Depends}, cowbuilder
+Homepage: http://www.netfort.gr.jp/~dancer/software/cowdancer.html
 Description: Copy-on-write directory tree utility.
  Tries to make copy-on-write semantics upon hard-link copied
  directory trees generated with 'cp -la'
@@ -33,10 +33,16 @@
 Description: pbuilder running on cowdancer
  'cowbuilder' command is a wrapper for pbuilder which allows using 
  pbuilder-like interface over cowdancer environment.
+ .
+ pbuilder is a tool for building and testing Debian package inside a clean
+ chroot, and cowbuilder allows chroot to be recreated using
+ hard-linked copies with copy-on-write, which makes creation and
+ destruction of chroots fast.
 
 Package: qemubuilder
 Architecture: i386 amd64 powerpc
 Depends: ${shlibs:Depends}, qemu | kvm, pbuilder (>= 0.174), debootstrap
+Homepage: http://wiki.debian.org/qemubuilder
 Description: pbuilder using QEMU as backend
  pbuilder implementation for QEMU.
  .
@@ -48,3 +54,8 @@
  .
  Gives a pbuilder interface for emulated cross-building environments
  using qemu.
+ .
+ pbuilder is a tool for building and testing Debian package inside a
+ clean chroot, and qemubuilder implements similar experience over
+ emulated CPUs. This tool allows building package inside emulated
+ Debian environment for different CPU architectures supported by qemu.

## cowdancer 0.62+nmu2

=== debian/changelog ===
cowdancer (0.62+nmu2) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply patch by Benoît Knecht to add the required additional arguments
    for networking (Closes: #597102)
  * Set urgency medium due to RC bug fix

 -- Alexander Reichle-Schmehl <tolimar@debian.org>  Thu, 02 Dec 2010 14:11:51 +0100

=== debian/rules ===
--- 
+++ 
@@ -76,7 +76,7 @@
 
 # (shell-command "cd ../ ; debian/rules debian/qemubuilder.README.Debian")
 debian/qemubuilder.README.Debian:
-	python debian/xmlrpc.py qemubuilder > $@.tmp
+	w3m -dump 'http://wiki.debian.org/qemubuilder?action=raw' > $@.tmp
 	mv $@.tmp $@
 
 binary: binary-indep binary-arch

## cowdancer 0.62+nmu2ubuntu1

=== debian/changelog ===
cowdancer (0.62+nmu2ubuntu1) natty; urgency=low

  * Fix linking with "ld --as-needed" by moving "-ldl" to the end of the
    linker call.

 -- Michael Bienia <geser@ubuntu.com>  Tue, 04 Jan 2011 11:03:49 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: cowdancer
 Section: utils
 Priority: optional
-Maintainer: Junichi Uekawa <dancer@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Junichi Uekawa <dancer@debian.org>
 Build-Depends: debhelper (>> 4.0.0), pbuilder, qemu [i386 amd64 powerpc], 
 	       libklibc-dev, klibc-utils, cpio, busybox-static
 Standards-Version: 3.7.2

## cowdancer 0.64

=== debian/changelog ===
cowdancer (0.64) unstable; urgency=low

  [ Junichi Uekawa ]
  * change default to use arch diskdevice of sd; most arches probably
    switched to /dev/sda by now.
  * binary-arch support for cowbuilder and qemubuilder (closes: #623978,
    #631967)
  * fix spelling mistake (closes: #623971)

  [ Benoît Knecht ]
  * qemubuilder: low read/write performance on qemu block devices
    (closes: #600056)

  [ Mike Gabriel ]
  * adds --othermirror option functionality to qemubuilder 
    (closes: #624012) 

 -- Junichi Uekawa <dancer@debian.org>  Tue, 02 Aug 2011 07:19:33 +0900

cowdancer (0.63) unstable; urgency=low

  * Acknowledge NMUs. (closes: #597102, #564425)

 -- Junichi Uekawa <dancer@debian.org>  Sun, 26 Jun 2011 09:21:02 +0900

## cowdancer 0.65

=== debian/changelog ===
cowdancer (0.65) unstable; urgency=low

  [ Junichi Uekawa ]
  * remove cowbuilder-cowdancer loop dependency. (closes: #519130)

  [ David Paleino ]
  * update cowbuilder bash completion (closes: #546725)

 -- Junichi Uekawa <dancer@debian.org>  Thu, 22 Sep 2011 11:29:48 +0900

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: cowdancer
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Junichi Uekawa <dancer@debian.org>
+Maintainer: Junichi Uekawa <dancer@debian.org>
 Build-Depends: debhelper (>> 4.0.0), pbuilder, qemu [i386 amd64 powerpc], 
 	       libklibc-dev, klibc-utils, cpio, busybox-static
 Standards-Version: 3.7.2
@@ -11,9 +10,7 @@
 
 Package: cowdancer
 Architecture: any
-# cowbuilder dependency is for backward compatibility, will be removed
-# after squeeze is released.
-Depends: ${shlibs:Depends}, cowbuilder
+Depends: ${shlibs:Depends}
 Homepage: http://www.netfort.gr.jp/~dancer/software/cowdancer.html
 Description: Copy-on-write directory tree utility.
  Tries to make copy-on-write semantics upon hard-link copied

## cowdancer 0.65ubuntu1

=== debian/changelog ===
cowdancer (0.65ubuntu1) precise; urgency=low

  * Fix link order to list libraries after the objects that require them.
  * Use -pthread rather than -lpthread, since it should be a superset, it's
    what's recommended in pthread_create(3), and it isn't so sensitive to
    link order.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 11 Nov 2011 14:57:27 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: cowdancer
 Section: utils
 Priority: optional
-Maintainer: Junichi Uekawa <dancer@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Junichi Uekawa <dancer@debian.org>
 Build-Depends: debhelper (>> 4.0.0), pbuilder, qemu [i386 amd64 powerpc], 
 	       libklibc-dev, klibc-utils, cpio, busybox-static
 Standards-Version: 3.7.2

## cowdancer 0.66

=== debian/changelog ===
cowdancer (0.66) unstable; urgency=low

  [ Colin Watson ]
  * Bug#648438: cowdancer: FTBFS with ld that defaults to --as-needed:
    bad link order

  [ Junichi Uekawa ]
  * note down where 573126 happens.

 -- Junichi Uekawa <dancer@debian.org>  Sun, 04 Dec 2011 22:44:38 +0900

## cowdancer 0.67

=== Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 	$(INSTALL_FILE) bash_completion.cowbuilder $(DESTDIR)/etc/bash_completion.d/cowbuilder
 
 libcowdancer.so: cowdancer.lo ilistcreate.lo
-	$(CC) $(CFLAGS) -ldl -shared -o $@ $^
+	$(CC) $(CFLAGS) -shared -o $@ $^ -ldl
 
 cow-shell: cow-shell.o ilistcreate.o
 	$(CC) $(CFLAGS) -o $@ $^

=== debian/changelog ===
cowdancer (0.67) unstable; urgency=low

  [ Junichi Uekawa ]
  * qemubuilder: work around case when othermirror is NULL (unset).
  * qemubuilder: Add --http-proxy to list of parameters for qemubuilder to override.

  [ Werner Mahr ]
  * qemubuilder: Apt inside the emulated system doesn't know
    about outside proxy (closes: #653162)

 -- Junichi Uekawa <dancer@debian.org>  Sun, 25 Dec 2011 16:21:03 +0900
